#include "MonitorInfo.h"

int initModuleEx(HWND hParent, HINSTANCE hInst, LPCSTR pszPath)
{
	hwndParent = hParent;
	hInstance = hInst;

	WNDCLASS wc = { 0 };
	wc.lpfnWndProc = WndProc;
	wc.hInstance = hInst;
	wc.lpszClassName = szAppName;
	
	RegisterClass(&wc);

	hwndMain = CreateWindowEx(WS_EX_TOOLWINDOW, szAppName, NULL, WS_POPUP, 0, 0, 0, 0, NULL, NULL, hInst, NULL);
	SendMessage(hwndParent, LM_REGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);

	writeMonitorInfo();

	return 0;
}

void quitModule(HINSTANCE hInst)
{
	SendMessage(hwndParent, LM_UNREGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);

	DestroyWindow(hwndMain);
	UnregisterClass(szAppName, hInst);

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
		case LM_GETREVID: {
			if (wParam == 0 || wParam == 1) {
				LPSTR buf = (LPSTR)lParam;
				strcpy(buf, szVersion);
                return strlen(buf);
            }
			return 0;
		}
		break;

        case LM_REFRESH: {
			writeMonitorInfo();
        }
        break;
	}
	return DefWindowProc(hwnd, msg, wParam, lParam);
}

void writeMonitorInfo() {
	monitorIndex = 0;
	EnumDisplayMonitors(NULL, NULL, EnumMonitorsProc, 0);
	char configDirLocation[MAX_LINE_LENGTH];
	GetRCString("ConfigDir", configDirLocation, "", MAX_LINE_LENGTH);
	char fileLocation[MAX_LINE_LENGTH];
	GetRCString("MonitorInfoFile", fileLocation, "", MAX_LINE_LENGTH);
	BOOL writeFile;
	writeFile = GetRCBool("MonitorInfoNoFile", FALSE);
	if (writeFile) {
		if (stricmp(fileLocation, "") != 0) {
			writeMonitorInfoFile(fileLocation);
		}
		else if (stricmp(configDirLocation, "") != 0) {
			strcat(configDirLocation, "MonitorInfo.rc");
			writeMonitorInfoFile(configDirLocation);
		}
	}
	writeMonitorInfoEvars();
}

void writeMonitorInfoEvars() {
	char szTempVar[MAX_LINE_LENGTH];
	char szTempVal[MAX_LINE_LENGTH];
	itoa(monitorIndex, szTempVal, 10);
	LSSetVariable("NumberOfMonitors", szTempVal);
	for (int x = 0; x < monitorIndex; x++) {
		sprintf(szTempVar, "Monitor%dTop", x+1);
		itoa(monitorInfoArray[x].rcMonitor.top, szTempVal, 10);
		LSSetVariable(szTempVar, szTempVal);
		sprintf(szTempVar, "Monitor%dBottom", x+1);
		itoa(monitorInfoArray[x].rcMonitor.bottom, szTempVal, 10);
		LSSetVariable(szTempVar, szTempVal);
		sprintf(szTempVar, "Monitor%dLeft", x+1);
		itoa(monitorInfoArray[x].rcMonitor.left, szTempVal, 10);
		LSSetVariable(szTempVar, szTempVal);
		sprintf(szTempVar, "Monitor%dRight", x+1);
		itoa(monitorInfoArray[x].rcMonitor.right, szTempVal, 10);
		LSSetVariable(szTempVar, szTempVal);
		if (monitorInfoArray[x].dwFlags == MONITORINFOF_PRIMARY) {
			sprintf(szTempVar, "Monitor%dPrimary", x+1);
			LSSetVariable(szTempVar, "true");
		}
		else {
			sprintf(szTempVar, "Monitor%dPrimary", x+1);
			LSSetVariable(szTempVar, "false");
		}
	}
}

void writeMonitorInfoFile(char* fileLocation) {
	FILE *filePointer;
	if (!(filePointer = fopen(fileLocation, "w"))) {
		return;
	}
	fprintf(filePointer, "NumberOfMonitors\t%d\n", monitorIndex);
	for (int x = 0; x < monitorIndex; x++) {
		fprintf(filePointer, "Monitor%dTop\t%d\n", x+1, monitorInfoArray[x].rcMonitor.top);
		fprintf(filePointer, "Monitor%dBottom\t%d\n", x+1, monitorInfoArray[x].rcMonitor.bottom);
		fprintf(filePointer, "Monitor%dLeft\t%d\n", x+1, monitorInfoArray[x].rcMonitor.left);
		fprintf(filePointer, "Monitor%dRight\t%d\n", x+1, monitorInfoArray[x].rcMonitor.right);
		if (monitorInfoArray[x].dwFlags == MONITORINFOF_PRIMARY) {
			fprintf(filePointer, "Monitor%dPrimary\t%s\n", x+1, "true");
		}
		else {
			fprintf(filePointer, "Monitor%dPrimary\t%s\n", x+1, "false");
		}
	}
	fclose(filePointer);
}

BOOL CALLBACK EnumMonitorsProc(HMONITOR hMonitor, HDC hdc, LPRECT lpRMonitor, LPARAM dwData) {
	
	MONITORINFO mi = { sizeof(MONITORINFO) };
	GetMonitorInfo(hMonitor, &mi);
	monitorInfoArray[monitorIndex] = mi;
	monitorIndex++;

	return true;
}